/*
  UniStep.h - Library for unipolar steppers.
  Created by Matthew Jones, December 18, 2014.
  Released into the public domain.
  
  This library tracks the phase and step of unipolar 5 wire stepper motors.
  http://arduino.cc/en/Hacking/LibraryTutorial
*/

#ifndef unistep_h
#define unistep_h

#include "Arduino.h"

class unistep
{
  public:
    unistep(int _p1, int _p2, int _p3, int _p4, int _steps, int _stepdelay);
    void moves(int steps, int dir);
    int print();
    //would be usefull to have a goto position? with direction also. 
  private:
    int phase; //the curret phase setp
    int p1; //output pin
    int p2; //output pin
    int p3; //output pin
    int p4; //output pin
    int steptime; //the delay time between steps
    int stepsperrev; //the number of steps in one ref zero indexed. 
    int currentstep; //the current step number, zero indexed. 
    void step1();
    void step0();
    void goto1();
    void goto2();
    void goto3();
    void goto4();
    void goto5();
    void goto6();
    void goto7();
    void goto0();
    //void gotophase(int p);
};

#endif
